package com.baileyhollingsworth.warpscrolls.item;

import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.*;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.util.text.TextFormatting;
import net.minecraft.world.World;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import java.util.List;

/**
 * Created by Bailey on 5/21/2016.
 */
public class ItemWarpScroll extends Item{

    public ItemWarpScroll() {
        func_77655_b("item_warp_scroll");
        setRegistryName("item_warp_scroll");
        func_77625_d(1);
        func_77656_e(1);
        func_77637_a(CreativeTabs.field_78037_j);
        GameRegistry.register(this);
    }
    @Override
    public ActionResult<ItemStack> func_77659_a(World worldIn, EntityPlayer playerIn, EnumHand handIn)
    {
        ItemStack itemStackIn = playerIn.func_184586_b(handIn);
        if(!playerIn.func_70093_af() && itemStackIn.func_77978_p().func_74759_k("blockPos") != null){
            int[] positionArray = itemStackIn.func_77978_p().func_74759_k("blockPos");
            try {
                if(itemStackIn.func_77978_p().func_74762_e("dim") == playerIn.field_71093_bK) {
                    playerIn.func_184595_k(positionArray[0], positionArray[1], positionArray[2]);
                    itemStackIn.func_77972_a(1, playerIn);
                    //Just because I am scared of servers crashing
                    try {
                        playerIn.func_184185_a(SoundEvent.field_187505_a.func_82594_a(new ResourceLocation("entity.endermen.teleport")), 2, 1);
                    } catch (Throwable t) {
                    }
                }else{
                    playerIn.func_146105_b(new TextComponentString(TextFormatting.LIGHT_PURPLE + "Attempting to teleport in a different dimension would be a bad idea."), true);
                }
            }catch(Exception e){
                System.out.println("Player tried to teleport with a bad scroll or a sound attempted to crash the server.");
            }
        }else if(playerIn.func_70093_af()){
            //Pass an array of the positions to reparse later.
            NBTTagCompound tag = new NBTTagCompound();
            tag.func_74783_a("blockPos", new int[]{ (int)playerIn.field_70165_t, (int) playerIn.field_70163_u, (int) playerIn.field_70161_v});
            tag.func_74768_a("dim", playerIn.field_71093_bK);
            itemStackIn.func_77982_d(tag);
            playerIn.func_146105_b(new TextComponentString(TextFormatting.LIGHT_PURPLE + "Location has been set at X: " +
                    (int)playerIn.field_70165_t + " Y: " + (int)playerIn.field_70163_u + " Z: " + (int)playerIn.field_70161_v), true);
        }
        return new ActionResult(EnumActionResult.PASS, playerIn.func_184586_b(handIn));
    }
    public void func_77663_a(ItemStack stack, World worldIn, Entity entityIn, int itemSlot, boolean isSelected)
    {
        if(stack.func_77978_p() == null){
            stack.func_77982_d(new NBTTagCompound());
        }
        if(stack.func_77958_k() - stack.func_77952_i() == 1){
            stack.func_77972_a(1, (EntityLivingBase)entityIn);
        }
    }

    @SideOnly(Side.CLIENT)
    public void func_77624_a(ItemStack stack, EntityPlayer playerIn, List<String> tooltip, boolean advanced)
    {
        tooltip.add("No location set. Right click while sneaking to set location.");
        try {
            if(stack.func_77978_p() == null){
                return;
            }else {
                int[] pos = stack.func_77978_p().func_74759_k("blockPos");
                if (pos != null) {
                    tooltip.set(1, "X: " + pos[0] + " Y: " + pos[1] + " Z: " + pos[2] + ". Right-click while sneaking to set again.");
                }
            }
        } catch (Exception e) {

        }
    }
    @SideOnly(Side.CLIENT)
    public void initModel() {
        ModelLoader.setCustomModelResourceLocation(this, 0, new ModelResourceLocation(getRegistryName(), "inventory"));
    }
}
